package trashplace.btTest1;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class PIDSettings extends Activity implements OnClickListener {

	static EditText							etRollP, etRollI, etRollD;
	static EditText							etPitchP, etPitchI, etPitchD;
	static EditText							etYawP, etYawI, etYawD;

	static EditText							etLevelP, etLevelI;
	static EditText							etRollPitchRate, etYawRate;
	static EditText							etRcRate, etRcExpo;
	static EditText							etDynThrPID;

	static Button							bPIDRead, bPIDWrite;

	static TextView							tvPIDLog;						// f. debugging

	public static BluetoothSerialService	mSerialService;
	public static mwcParser					mMWCParser;

	public static final String				TAG			= "PIDSettings";

	byte[]									settings	= new byte[22];	// Byte-Array with values prepared to get sent to MWC

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.setpid);

		etRollP = (EditText) findViewById(R.id.etRollP);
		etRollI = (EditText) findViewById(R.id.etRollI);
		etRollD = (EditText) findViewById(R.id.etRollD);

		etPitchP = (EditText) findViewById(R.id.etPitchP);
		etPitchI = (EditText) findViewById(R.id.etPitchI);
		etPitchD = (EditText) findViewById(R.id.etPitchD);

		etYawP = (EditText) findViewById(R.id.etYawP);
		etYawI = (EditText) findViewById(R.id.etYawI);
		etYawD = (EditText) findViewById(R.id.etYawD);

		etLevelP = (EditText) findViewById(R.id.etLevelP);
		etLevelI = (EditText) findViewById(R.id.etLevelI);
		etRollPitchRate = (EditText) findViewById(R.id.etRollPitchRate);
		etYawRate = (EditText) findViewById(R.id.etYawRate);
		etRcRate = (EditText) findViewById(R.id.etRcRate);
		etRcExpo = (EditText) findViewById(R.id.etRcExpo);
		etDynThrPID = (EditText) findViewById(R.id.etDynThrPID);

		bPIDRead = (Button) findViewById(R.id.bPIDRead);
		bPIDWrite = (Button) findViewById(R.id.bPIDWrite);

		tvPIDLog = (TextView) findViewById(R.id.tvPIDLog);

		mSerialService = btTest1Main.mSerialService;
		mMWCParser = btTest1Main.mMWCParser;

		bPIDRead.setOnClickListener(this);
		bPIDWrite.setOnClickListener(this);

		updateGUI();

	}

	public static void updateGUI() {
		etRollP.setText(String.format("%.1f", (float) (mMWCParser.P8[0]) / 10).replace(',', '.'));
		etRollI.setText(String.format("%.3f", (float) (mMWCParser.I8[0]) / 1000).replace(',', '.'));
		etRollD.setText(Integer.toString(mMWCParser.D8[0]).replace(',', '.'));

		etPitchP.setText(String.format("%.1f", (float) (mMWCParser.P8[1]) / 10).replace(',', '.'));
		etPitchI.setText(String.format("%.3f", (float) (mMWCParser.I8[1]) / 1000).replace(',', '.'));
		etPitchD.setText(Integer.toString(mMWCParser.D8[1]).replace(',', '.'));

		etYawP.setText(String.format("%.1f", (float) (mMWCParser.P8[2]) / 10).replace(',', '.'));
		etYawI.setText(String.format("%.3f", (float) (mMWCParser.I8[2]) / 1000).replace(',', '.'));
		etYawD.setText(Integer.toString(mMWCParser.D8[2]).replace(',', '.'));

		etLevelP.setText(String.format("%.1f", (float) (mMWCParser.PLEVEL8) / 10).replace(',', '.'));
		etLevelI.setText(String.format("%.3f", (float) (mMWCParser.ILEVEL8) / 1000).replace(',', '.'));
		etRollPitchRate.setText(Integer.toString(mMWCParser.rollPitchRate).replace(',', '.'));
		etYawRate.setText(Integer.toString(mMWCParser.yawRate).replace(',', '.'));
		etRcRate.setText(String.format("%.2f", (float) (mMWCParser.rcRate8) / 50).replace(',', '.'));
		etRcExpo.setText(String.format("%.2f", (float) (mMWCParser.rcExpo8) / 100).replace(',', '.'));
		etDynThrPID.setText(String.format("%.2f", (float) (mMWCParser.dynThrPID) / 100).replace(',', '.'));

	}


	void buildSettings() {
		settings[0] = 'C';

		settings[1] = (byte) new Float((Float.parseFloat(etRollP.getText().toString()) * 10)).intValue();
		settings[2] = (byte) new Float((Float.parseFloat(etRollI.getText().toString()) * 1000)).intValue();
		settings[3] = (byte) new Float((Float.parseFloat(etRollD.getText().toString()))).intValue();

		settings[4] = (byte) new Float((Float.parseFloat(etPitchP.getText().toString()) * 10)).intValue();
		settings[5] = (byte) new Float((Float.parseFloat(etPitchI.getText().toString()) * 1000)).intValue();
		settings[6] = (byte) new Float((Float.parseFloat(etPitchD.getText().toString()))).intValue();

		settings[7] = (byte) new Float((Float.parseFloat(etYawP.getText().toString()) * 10)).intValue();
		settings[8] = (byte) new Float((Float.parseFloat(etYawI.getText().toString()) * 1000)).intValue();
		settings[9] = (byte) new Float((Float.parseFloat(etYawD.getText().toString()))).intValue();

		settings[10] = (byte) new Float((Float.parseFloat(etLevelP.getText().toString()) * 10)).intValue();
		settings[11] = (byte) new Float((Float.parseFloat(etLevelI.getText().toString()) * 1000)).intValue();

		settings[12] = (byte) new Float((Float.parseFloat(etRcRate.getText().toString()) * 50)).intValue();
		settings[13] = (byte) new Float((Float.parseFloat(etRcExpo.getText().toString()) * 100)).intValue();

		settings[14] = (byte) new Float((Float.parseFloat(etRollPitchRate.getText().toString()))).intValue();
		settings[15] = (byte) new Float((Float.parseFloat(etYawRate.getText().toString()))).intValue();
		settings[16] = (byte) new Float((Float.parseFloat(etDynThrPID.getText().toString()) * 100)).intValue();

		settings[17] = (byte) mMWCParser.activateAcc8;
		settings[18] = (byte) mMWCParser.activateBaro8;
		settings[19] = (byte) mMWCParser.activateMag8;
		settings[20] = (byte) mMWCParser.activateCamStab8;
		settings[21] = (byte) mMWCParser.activateCamTrig8;

	}

	// onClick-handler f. Buttons
	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.bPIDRead:
			if (mSerialService.getState() == BluetoothSerialService.STATE_CONNECTED) {
				btTest1Main.mData.clear();
				tvPIDLog.setText("");
				//mSerialService.write("A".getBytes());
				btTest1Main.requestData();
			}

			//updateGUI();
			break;
		case R.id.bPIDWrite:
			buildSettings();
			int i;
			String s = "";
			tvPIDLog.setText("Settings:\n");
			for (i = 0; i < settings.length; i++) {
				if (i % 8 == 0) {
					tvPIDLog.append("\n");
				}
				s = String.format("%03d", settings[i]);
				tvPIDLog.append(s + " ");
			}
			mSerialService.write(settings);
			break;
		}
	}

}
